diff -c ../zip19i/fileio.c ./fileio.c
*** ../zip19i/fileio.c	Tue Nov  3 21:07:54 1992
--- ./fileio.c	Fri Sep 10 05:02:28 1993
***************
*** 1747,1811 ****
  char *d;                /* directory to delete */
  /* Delete the directory *d if it is empty, do nothing otherwise.
     Return the result of rmdir(), delete(), or system().
   */
  {
  #if (defined(MACOS) || defined(TOPS20))
!   warn("deletedir not implemented yet", "");
!   return 127;
! #else
! #ifdef RMDIR
!   /* code from Greg Roelofs, who horked it from Mark Edwards (unzip) */
!   int r, len;
!   char *s;              /* malloc'd string for system command */
! 
!   len = strlen(d);
!   if ((s = malloc(len + 34)) == NULL)
      return 127;
  
! #ifdef VMS
!   {
!     char *c;            /* pointer into VMS path */
!     /* convert "DEV:[DIR.SUB1.SUB2]" form to "DEV:[DIR.SUB1]SUB2.DIR;1" */
!     strcat(strcpy(s, "set prot=(o:rwed) "), d);   /* d starts at s+18 */
!     if (*(c = s+17+len) != ']')
!     {
!       free(s);
!       return 127;
!     }
!     strcpy(c, ".DIR;1");        /* directories are always version 1 */
!     while (--c > s+18  &&  *c != '.'  &&  *c != '[') ;
!     if (c == s+18)
!     {
!       free(s);
!       return 127;
!     }
!     if (*c == '.')
!       *c = ']';
!     else if (*--c == ']')  /* presumably of form "DEV:[DIR.SUB1.][SUB2]" */
!     {                      /* (possible to have "DEV:[DIR.SUB1.][][SUB2]"?) */
!       char *b = c + 2;
!       c[-1] = ']';
!       while (*c++ = *b++) ;
!     }
!     else        /* must have reached device name:  can't delete top level */
!     {
!       free(s);
        return 127;
!     }
!   }
!   /* unprotect directory and delete it as a file.  May fail if exists 
!      normal file "foo.dir" on top of directory "foo.dir" */
!   system(s);
!   r = delete(s+18);
! #else /* !VMS */
!   sprintf(s, "IFS=\" \t\n\" /bin/rmdir %s 2>/dev/null", d);
!   r = system(s);
! #endif /* ?VMS */
!   free(s);
!   return r;
! #else /* !RMDIR */
!   return rmdir(d);
! #endif /* ?RMDIR */
  #endif /* ? MACOS || TOPS20 */
  }
  
--- 2137,2170 ----
  char *d;                /* directory to delete */
  /* Delete the directory *d if it is empty, do nothing otherwise.
     Return the result of rmdir(), delete(), or system().
+    For VMS, d must be in format [x.y]z.dir;1  (not [x.y.z]).
   */
  {
  #if (defined(MACOS) || defined(TOPS20))
!     warn("deletedir not implemented yet", "");
      return 127;
+ #else
+ # ifdef RMDIR
+     /* code from Greg Roelofs, who horked it from Mark Edwards (unzip) */
+     int r, len;
+     char *s;              /* malloc'd string for system command */
  
!     len = strlen(d);
!     if ((s = malloc(len + 34)) == NULL)
        return 127;
! 
! #  ifdef VMS
!     system(strcat(strcpy(s, "set prot=(o:rwed) "), d));
!     r = delete(d);
! #  else /* !VMS */
!     sprintf(s, "IFS=\" \t\n\" /bin/rmdir %s 2>/dev/null", d);
!     r = system(s);
! #  endif /* ?VMS */
!     free(s);
!     return r;
! # else /* !RMDIR */
!     return rmdir(d);
! # endif /* ?RMDIR */
  #endif /* ? MACOS || TOPS20 */
  }
  
***************
*** 1823,1831 ****
  int replace(d, s)
  char *d, *s;            /* destination and source file names */
  /* Replace file *d by file *s, removing the old *s.  Return an error code
!    in the ZE_ class. */
  {
    struct stat t;        /* results of stat() */
  
  #ifdef VMS
    /* stat() is broken on VMS remote files (accessed through Decnet).
--- 2182,2194 ----
  int replace(d, s)
  char *d, *s;            /* destination and source file names */
  /* Replace file *d by file *s, removing the old *s.  Return an error code
!    in the ZE_ class. This function need not preserve the file attributes,
!    this will be done by setfileattr() later.
!  */
  {
    struct stat t;        /* results of stat() */
+   int copy = 0;
+   int d_exists;
  
  #ifdef VMS
    /* stat() is broken on VMS remote files (accessed through Decnet).
***************
*** 1833,1878 ****
     * to update them or compress remote files */
    unlink(d);
  #else
!   if (SSTAT(d, &t) == 0 && unlink(d))
!     return ZE_CREAT;                    /* Can't erase zip file--give up */
! #endif
!   if (link(s, d))                       /* Just move s on top of d */
! #if !defined(VMS) && !defined(ATARI_ST)
!     /* For VMS & ATARI assume failure is EXDEV */
!     if (errno != EXDEV
  #  ifdef ENOTSAM
!        && errno != ENOTSAM /* Used at least on Turbo C */
  #  endif
!         ) return ZE_CREAT;
!     else
  #endif
-     {
-       FILE *f, *g;      /* source and destination files */
-       int r;            /* temporary variable */
- 
-       if ((f = fopen(s, FOPR)) == NULL) {
-         fprintf(stderr," replace: can't open %s\n", s);
-         return ZE_TEMP;
        }
!       if ((g = fopen(d, FOPW)) == NULL)
!       {
!         fclose(f);
!         return ZE_CREAT;
        }
!       r = fcopy(f, g, (ulg)-1L);
        fclose(f);
!       if (fclose(g) || r != ZE_OK)
!       {
!         unlink(d);
!         return r ? (r == ZE_TEMP ? ZE_WRITE : r) : ZE_WRITE;
!       }
! #ifdef VMS /* only delete if rename failed:  previous version may exist */
!       unlink(s);
      }
! #else /* !VMS */
      }
!   unlink(s);
! #endif /* !VMS */
    return ZE_OK;
  }
  
--- 2196,2267 ----
     * to update them or compress remote files */
    unlink(d);
  #else
!   d_exists = (LSTAT(d, &t) == 0);
!   if (d_exists)
!   {
!     /*
!      * respect existing soft and hard links!
!      */
!     if (t.st_nlink > 1
! # ifdef S_IFLNK
!         || (t.st_mode & S_IFMT) == S_IFLNK
! # endif
!         )
!        copy = 1;
!     else if (unlink(d))
!        return ZE_CREAT;                 /* Can't erase zip file--give up */
!   }
! #endif /* VMS */
!   if (!copy) {
!       if (link(s, d)) {               /* Just move s on top of d */
!           copy = 1;                     /* failed ? */
! #if !defined(VMS) && !defined(ATARI_ST) && !defined(AZTEC_C)
!     /* For VMS & ATARI & AMIGA Aztec assume failure is EXDEV */
!           if (errno != EXDEV
  #  ifdef ENOTSAM
!            && errno != ENOTSAM /* Used at least on Turbo C */
  #  endif
!               ) return ZE_CREAT;
  #endif
        }
! #ifndef link    /* UNIX link() */
!       /*
!        * Assuming a UNIX link(2), we still have to remove s.
!        * If link has been #defined to rename(), nothing to do.
!        */
!       else {
! # ifdef KEEP_OWNER
!           if (d_exists)
!               /* this will fail if the user isn't priviledged */
!               chown(d, t.st_uid, t.st_gid);
! # endif
!           unlink(s);
        }
! #endif          /* ?UNIX link() */
!   }
! 
!   if (copy) {
!     FILE *f, *g;      /* source and destination files */
!     int r;            /* temporary variable */
! 
!     if ((f = fopen(s, FOPR)) == NULL) {
!       fprintf(stderr," replace: can't open %s\n", s);
!       return ZE_TEMP;
!     }
!     if ((g = fopen(d, FOPW)) == NULL)
!     {
        fclose(f);
!       return ZE_CREAT;
      }
!     r = fcopy(f, g, (ulg)-1L);
!     fclose(f);
!     if (fclose(g) || r != ZE_OK)
!     {
!       unlink(d);
!       return r ? (r == ZE_TEMP ? ZE_WRITE : r) : ZE_WRITE;
      }
!     unlink(s);
!   }
    return ZE_OK;
  }
  
***************
*** 1892,1932 ****
  int a;                  /* attributes returned by getfileattr() */
  /* Give the file f the attributes a, return non-zero on failure */
  {
! #if defined (VMS) || defined(MACOS) || defined(TOPS20)
    return 0;
! #else /* !VMS */
    return chmod(f, a);
! #endif /* ?VMS */
  }
  
  
- #ifdef NO_MKTEMP
- 
- char *tempname(zip)
-   char *zip;              /* path name of zip file to generate temp name for */
- 
- /* Return a temporary file name in its own malloc'ed space.
-  * This function might accidentally destroy an existing file
-  * with extension .$z$ . Use mktemp below if you have it on your system.
-  */
- {
-   char *p;              /* temporary pointer */
-   char *t;              /* malloc'ed space for name */
- 
-   if ((t = malloc(strlen(zip)+5)) == NULL)
-     return NULL;
-   strcpy(t, zip);
-   if ((p = strrchr(t, '.')) != NULL &&
-       (!strncmp(p, ".zip", 4) || !strncmp(p, ".ZIP", 4)))
-       /* strncmp to avoid problems with VMS ';' */
-     strcpy(p, ".$z$");
-   else
-     strcat(t, ".$z$");
- 
-   return t;
- }
- #else /* !NO_MKTEMP */
- 
  char *tempname(zip)
    char *zip;              /* path name of zip file to generate temp name for */
  
--- 2281,2294 ----
  int a;                  /* attributes returned by getfileattr() */
  /* Give the file f the attributes a, return non-zero on failure */
  {
! #if defined(MACOS) || defined(TOPS20)
    return 0;
! #else
    return chmod(f, a);
! #endif
  }
  
  
  char *tempname(zip)
    char *zip;              /* path name of zip file to generate temp name for */
  
***************
*** 1936,1962 ****
  
    if (tempath != NULL)
    {
!     if ((t = malloc(strlen(tempath)+10)) == NULL)
        return NULL;
      strcpy(t, tempath);
  #if (!defined(VMS) && !defined(TOPS20))
      if (t[strlen(t)-1] != '/')
        strcat(t, "/");
  #endif
    }
    else
    {
!     if ((t = malloc(9)) == NULL)
        return NULL;
      *t = 0;
    }
    strcat(t, "_ZXXXXXX");
    return mktemp(t);
  }
  
- #endif /* NO_MKTEMP */
  
- 
  int fcopy(f, g, n)
  FILE *f, *g;            /* source and destination files */
  ulg n;                  /* number of bytes to copy or -1 for all */
--- 2298,2339 ----
  
    if (tempath != NULL)
    {
!     if ((t = malloc(strlen(tempath)+12)) == NULL)
        return NULL;
      strcpy(t, tempath);
  #if (!defined(VMS) && !defined(TOPS20))
+ #  ifdef AMIGA
+     {
+           char c = t[strlen(t)-1];
+           if (c != '/' && c != ':')
+             strcat(t, "/");
+     }
+ #  else /* !AMIGA */
+           
      if (t[strlen(t)-1] != '/')
        strcat(t, "/");
+ #  endif  /* ?AMIGA */            
  #endif
    }
    else
    {
!     if ((t = malloc(12)) == NULL)
        return NULL;
      *t = 0;
    }
+ #ifdef NO_MKTEMP
+   {
+     char *p = t + strlen(t);
+     sprintf(p, "%08lx", (ulg)time(NULL));
+     return t;
+   }
+ #else
    strcat(t, "_ZXXXXXX");
    return mktemp(t);
+ #endif
  }
  
  
  int fcopy(f, g, n)
  FILE *f, *g;            /* source and destination files */
  ulg n;                  /* number of bytes to copy or -1 for all */
***************
*** 2060,2088 ****
  #ifdef TOPS20
  
  int
! strupper(s)	/* Returns s in uppercase */
! char *s;	/* String to be uppercased */
  {
      char    *p;
  
      p = s;
      for (; *p; p++)
! 	*p = toupper (*p);
  }
  
  int
! strlower(s)	/* Returns s in lowercase. */
! char *s;	/* String to be lowercased */
  {
      char    *p;
  
      p = s;
      for (; *p; p++)
! 	*p = tolower (*p);
  }
  #endif /* TOPS20 */
  
! #ifdef __TURBOC__
  
  /************************/
  /*  Function fcalloc()  */
--- 2437,2465 ----
  #ifdef TOPS20
  
  int
! strupper(s)     /* Returns s in uppercase */
! char *s;        /* String to be uppercased */
  {
      char    *p;
  
      p = s;
      for (; *p; p++)
!         *p = toupper (*p);
  }
  
  int
! strlower(s)     /* Returns s in lowercase. */
! char *s;        /* String to be lowercased */
  {
      char    *p;
  
      p = s;
      for (; *p; p++)
!         *p = tolower (*p);
  }
  #endif /* TOPS20 */
  
! #if defined(__TURBOC__) && !defined(OS2)
  
  /************************/
  /*  Function fcalloc()  */
***************
*** 2091,2108 ****
  /* Turbo C malloc() does not allow dynamic allocation of 64K bytes
   * and farmalloc(64K) returns a pointer with an offset of 8, so we
   * must fix the pointer. Warning: the pointer must be put back to its
!  * original form in order to free it.
   * For MSC, use halloc instead of this function (see tailor.h).
   */
! void far * fcalloc(items, size)
      unsigned items; /* number of items */
      unsigned size;  /* item size */
  {
!     void far * buf = farmalloc((ulg)items*size + 16L);
      /* Normalize the pointer to seg:0 */
!     *((int*)&buf+1) += ((unsigned)((uch*)buf-0) + 15) >> 4;
!     *(int*)&buf = 0;
!     return buf; /* buf stays NULL if alloc failed */
! }
  
! #endif /* __TURBOC__ */
--- 2468,2502 ----
  /* Turbo C malloc() does not allow dynamic allocation of 64K bytes
   * and farmalloc(64K) returns a pointer with an offset of 8, so we
   * must fix the pointer. Warning: the pointer must be put back to its
!  * original form in order to free it, use fcfree().
   * For MSC, use halloc instead of this function (see tailor.h).
   */
! static ush ptr_offset = 0;
! 
! void * fcalloc(items, size)
      unsigned items; /* number of items */
      unsigned size;  /* item size */
  {
!     void * buf = farmalloc((ulg)items*size + 16L);
!     if (buf == NULL) return NULL;
      /* Normalize the pointer to seg:0 */
!     if (ptr_offset == 0) {
!         ptr_offset = (ush)((uch*)buf-0);
!     } else if (ptr_offset != (ush)((uch*)buf-0)) {
!         err(ZE_LOGIC, "inconsistent ptr_offset");
!     }
!     *((ush*)&buf+1) += (ptr_offset + 15) >> 4;
!     *(ush*)&buf = 0;
!     return buf;
! }
! 
! void fcfree(ptr)
!     void *ptr; /* region allocated with fcalloc() */
! {
!     /* Put the pointer back to its original form: */
!     *((ush*)&ptr+1) -= (ptr_offset + 15) >> 4;
!     *(ush*)&ptr = ptr_offset;
!     farfree(ptr);
!  }
  
! #endif /* __TURBOC__ && !OS2 */
diff -c ../zip19i/globals.c ./globals.c
*** ../zip19i/globals.c	Tue Nov  3 21:07:54 1992
--- ./globals.c	Fri Sep 10 00:03:42 1993
***************
*** 1,11 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
--- 1,10 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
***************
*** 14,19 ****
--- 13,20 ----
   */
  
  #define GLOBALS         /* include definition of errors[] in zip.h */
+ #define UTIL            /* do not declare the read_buf variable */
+ 
  #include "zip.h"
  
  
***************
*** 22,40 ****
  
  /* Argument processing globals */
  int recurse = 0;        /* 1=recurse into directories encountered */
  int pathput = 1;        /* 1=store path with name */
  int method = BEST;      /* one of BEST, DEFLATE (only), or STORE (only) */
  int dosify = 0;         /* 1=make new entries look like MSDOS */
  int verbose = 0;        /* 1=report oddities in zip file structure */
! int level = 5;          /* 0=fastest compression, 9=best compression */
  int translate_eol = 0;  /* Translate end-of-line LF -> CR LF */
  #ifdef VMS
     int vmsver = 0;      /* 1=append VMS version number to file names */
     int vms_native = 0;  /* 1=store in VMS format */
  #endif /* VMS */
! #ifdef OS2
     int use_longname_ea = 0; /* 1=use the .LONGNAME EA as the file's name */
! #endif /* OS2 */
  int linkput = 0;        /* 1=store symbolic links as such */
  int noisy = 1;          /* 0=quiet operation */
  char *special = ".Z:.zip:.zoo:.arc:.lzh:.arj"; /* List of special suffixes */
--- 23,46 ----
  
  /* Argument processing globals */
  int recurse = 0;        /* 1=recurse into directories encountered */
+ int dispose = 0;        /* 1=remove files after put in zip file */
  int pathput = 1;        /* 1=store path with name */
  int method = BEST;      /* one of BEST, DEFLATE (only), or STORE (only) */
  int dosify = 0;         /* 1=make new entries look like MSDOS */
  int verbose = 0;        /* 1=report oddities in zip file structure */
! int fix = 0;            /* 1=fix the zip file */
! int level = 6;          /* 0=fastest compression, 9=best compression */
  int translate_eol = 0;  /* Translate end-of-line LF -> CR LF */
  #ifdef VMS
     int vmsver = 0;      /* 1=append VMS version number to file names */
     int vms_native = 0;  /* 1=store in VMS format */
  #endif /* VMS */
! #if defined(OS2) || defined(WIN32)
     int use_longname_ea = 0; /* 1=use the .LONGNAME EA as the file's name */
! #endif
! int hidden_files = 0;   /* process hidden and system files */
! int volume_label = 0;   /* add volume label */
! int dirnames = 1;       /* include directory entries by default */
  int linkput = 0;        /* 1=store symbolic links as such */
  int noisy = 1;          /* 0=quiet operation */
  char *special = ".Z:.zip:.zoo:.arc:.lzh:.arj"; /* List of special suffixes */
***************
*** 58,60 ****
--- 64,71 ----
  struct flist far * far *fnxt = &found;
                          /* Where to put next name in found list */
  extent fcount;          /* Count of files in list */
+ 
+ /* Patterns to be matched */
+ struct plist *patterns = NULL; /* List of patterns to be matched */
+ int pcount = 0;                /* number of patterns */
+ int icount = 0;                /* number of include only patterns */
diff -c ../zip19i/history ./history
*** ../zip19i/history	Tue Nov  3 21:07:55 1992
--- ./history	Fri Sep 10 04:56:54 1993
***************
*** 1058,1080 ****
  7.  Use large model for BC++, _TEXT exceeds 64K (Onno)
  8.  Started cleanup by partial removal of "far" keyword.
  
! 
! Things to check or to be done (see also BUGS section in zip.1):
! 
! - Michael Regoli <mr@ogre.cica.indiana.edu> reports that zip 1.9g does
!   not compile on a Sun 4 with gcc 2.2.2 but I have the same configuration
!   and can't reproduce it.
! 
! - On VMS, "zip -rm" deletes too many directories and in the wrong
!   order. Greg is looking at this.
! 
! - On VMS, "zip -r foo [x.y]" does not work. "zip -r foo [x]y.dir" works.
! 
! - There is not (yet) a way to undo the effect of ZIPOPT
! 
! - it is possible in weird cases to add a zipfile to itself
! 
! - The -b option is ignored on OS/2.
! 
! - On OS/2, zip refuses to match some names, such as those beginning with an
!   exclamation mark. Same for names starting with #, possibly more.
--- 1058,1273 ----
  7.  Use large model for BC++, _TEXT exceeds 64K (Onno)
  8.  Started cleanup by partial removal of "far" keyword.
  
! ------------------------ Nov 21  1992   version 1.9j ------------------------
! 1.  Simplified trash() and deletedir() significantly, fixing the VMS zip -r
!     bug as a side effect (Greg).
! 2.  tailor.h: djgcc warns about using a char as array index (Onno)
! 3.  makefile.bor and match.asm: changed LARGE to __LARGE__ because LARGE
!     is a reserved word in tasm. (Onno)
! 4.  Added a workaround for a bug in latest version of OS/2 (Kai Uwe)
! 5.  Added -Z to CLFAGS in makefile.bor (Zachary Heilig)
! 6.  Quote "-T" in help screen for VMS (Greg)
! 7.  Added -c to CFLAGS in makefile.gcc (Bob Hardy)
! 9.  Added rs6000 makefile entry as in unzip (Michael Bernardi)
! 10. Renamed makefile as Makefile for unification with unzip
! 11. Added makefile entry for Pixel (Aubrey Jaffer)
! 12. Use nice_match in match.s to guarantee same output as C code.
! 13. Fixed "version made by" for OS/2 in zipup.c (Kai-Uwe)
! 14. Aligned messages with : as in unzip (Kai-Uwe)
! 15. New Amiga support (John Bush)
! 16. Forget the "#define const" which was source of trouble.
! 17. Do not use a directory time for -o (Onno)
! 
! 
! ------------------------ Nov 24  1992   version 1.9k ------------------------
! 1.  Define const for non ANSI compilers (Michael Lawler)
! 2.  Removed the .dif files from the amiga subdirectory (John Bush)
! 3.  Added automatic configuration with "make generic"
! 
! ------------------------ Jan 26  1993   version 1.9l ------------------------
! 1.  Add trap handler in configure
! 2.  Use readdir() for 386BSD (Onno)
! 3.  New work around for OS/2 bug in os2zip.c (Kai Uwe).
! 4.  Commented out declarations of opendir and readdir (was causing
!     problems with 'const'). (Mark).
! 5.  Process -@ only after the zip file is read (George Sipe)
! 6.  Added check for NeXT in configure (Mark)
! 7.  Define SYSV only if sys/termio.h exists
! 8.  Don't use gcc -c -c in msdos/makefile.gcc (Onno)
! 9.  Don't include sys/types.h for Amiga (John)
! 10. Added support for pgp in trees.c
! 11. Use nice_match in match.asm
! 12. Do not attempt matches beyond the window end (caused crash on 286 in
!     protected mode when attempting a word load at address DS:FFFF).
! 13. Fixed location of zcrypt19.zip in Where.
! 14. Do not check file size on MSDOS because of bug in DIET
! 15. Set 'version needed to extract' to 1.0 for stored files (Peter Gutmann)
! 16. Do not ignore the time of the first entry for -o (Mark).
! 17. Allow zip -r0 with output to a pipe (Mark)
! 18. Never include a zip file in itself or remove it at the end with -m.
! 19. Fix zip -r on VMS to include all versions (;*).  (Igor)
! 20. Don't forget closedir() on error (Kai Uwe)
! 21. Ignore ftell() error on pipes (Eric Backus)
! 22. Don't free() the literal string "-" (Eric Backus)
! 23. Don't call err() with a null pointer (Eric Backus)
! 24. Put back percent() arguments as ulg (Mark).
! 25. New os2/zip.def and os2zip.c (Kai Uwe)
! 26. Fixes in tailor.h for OS2 (Kai Uwe)
! 27. Fix for zero length indexed files (Igor)
! 
! ------------------------ Aug 20  1993   version 1.9m ------------------------
! 1.  1992->1993 in all copyright notices.
! 2.  Added "make bull" (doc@magna.com (Matthew J. D'Errico)
! 3.  Fixed vms_stat() to work across Decnet (Igor)
! 4.  Use ; instead of , in trees.c (confuses the SAS Amiga compiler).
! 5.  Added instructions for info-zip lists.
! 6.  Add the -F and -FF (zipfix) options.
! 7.  Documented the -v option.
! 8.  Use progress indicator also for zip -0 (Greg).
! 9.  Document /etc/magic line in install.doc.
! 10. Changed os2 stack size from 0x40000 to 0x80000 to avoid OS/2 bugs.
! 11. Don't use name foo.zip.$z$ on OS/2 FAT system.
! 12. Do not ignore the -l option with zip -0.
! 13. Updated Where file.
! 14. In zip.1, mention pkzip 2.04 instead of 1.93a.
! 15. Fix test for regular files in filetime().
! 16. In memcompress(), do not call deflate with compression level 0.
! 17. Display 0 instead of gargabe for negative compression ratios.
! 18. New amiga files. (diffs not yet applied, will be changed shortly)
! 19. Speed up zip -1 to -3 as in gzip, default changed to -6.
! 20. Fix problem of zip -r with symbolic link to non existent file.
! 21. Do not use _dos_getfileaddr() for Borland C++ (James W. Birdsall)
! 22. Fix compilation error in vms.c with GNU cc (Mike Freeman)
! 23. make the file that zipnote generates somewhat self-documenting, and allow
!     the zipnote -w input to be a little more free form. (Mark)
! 24. Added support for Borland C++ for OS/2 (32-bit) (Kai-Uwe).
! 25. Added makefile for Turbo C 2.0 (Andrew Cadach)
! 26. Added untested makefile entry for SCO Xenix on 286.
! 27. Add -S option to include hidden/system files on MSDOS/OS/2 (Kai Uwe).
! 28. Free the extra field as soon as it is written on disk.
! 29. Use -DSYSV for "make sun" so that it also works on Solaris. Add sun_bsd.
! 30. Added "make next-fat".
! 
! 
! ------------------------ Aug 21  1993   version 1.9n ------------------------
! 1.  Don't undef const in crypt.c (does not work on MSDOS).
! 2.  Fix some warnings with MSDOS compilers.
! 3.  Switch to large model for all 16 bit MSDOS compilers.
! 4.  New match.s with 68K support, and to avoid problems with DJGPP 1.10.
! 5.  When -b is used, do not create any file other than the final zipfile
!     in the final directory. (Don't leave junk on a WORM.)
! 
! ------------------------ Aug 29  1993   version 2.0a ------------------------
! 1.  Free local extra field only if different from central extra field (Kai Uwe)
! 2.  Use size_t instead of unsigned in os2/os2zip.c
! 3.  Fix for emx in os2/makefile.os2.
! 4.  Fix change 5 of zip 1.9n (was allowing destruction of a readonly file).
! 5.  next-fat -> nextfat to make Greg happy.
! 6.  Fix macros in vms/descrip.mms (Igor).
! 7.  Free the local extra field only after the second putlocal() (Igor).
! 8.  Add vms.obj in make_vaxc.com for zipsplit, zipnote, zipcloak (Mike Freeman)
! 9.  Don't use the constant (unsigned)2*32768 with 16-bit int (Piet Plomp).
! 10. Use syntax acceptable by ml in msdos/makefile.msc (Piet Plomp).
! 11. Use const if MODERN instead of __STDC__ (Greg).
! 12. Remove garbage at both ends of zip file with -F or -FF (Bill Davidsen)
! 13. Added support for Human68K (NIIMI Satoshi)
! 14. Preserve existing soft and hard links for the zip file (Martin Schulz)
! 15. Don't crash when no zip-file, with flag -o (Martin Schulz)
! 16. Ignore -y when -k is set (Martin Schulz)
! 17. Add the -D option (create entries for directories)
! 18. Free window and hash table (when -DDYN_ALLOC) before calling unzip for -T.
! 19. Remove -m4 from msdos/makefile.tc (not supported by TurboC 2.0)
! 20. Fix handling of system/hidden files for Windows/NT (Martin Schulz)
! 21. Get correct file times for Windows/NT (Martin Schulz)
! 22. Upper case conversion for Windows/NT depends on FAT (Martin Schulz)
! 23. Keep old internal name when updating on MSDOS a zipfile made on Unix:
!     "zip foo Makefile" no longer changes Makefile into makefile.
! 24. Do not recurse while excluding.
! 25. Add -i option. Simplify the -x code.
! 26. Include the volume label for the -S option.
! 
! ------------------------ Sep 1st  1993   version 2.0b ------------------------
! 1.  Do not use process.h in dummy/zipcloak.c
! 2.  Support volume labels for OS/2 (Kai Uwe)
! 3.  Include volume label even if file patterns do not include the root dir.
! 4.  Fixed copyright notice.
! 5.  Fixed zip -FF code (do not copy the bad compressed size)
! 6.  Add warning if -F would truncate the zip file.
! 7.  Use a specific option for volume label (-$ as in pkzip and arj).
! 8.  Better Amiga support (John Bush and Paul Kienitz).
! 9.  Define UNIX for Unix systems (Greg).
! 10. Link util_ for zipcloak (Mike Freeman)
! 11. Suppress all the TurboC .prj and .tc files; makefile.tc is more convenient.
! 12. Include only the dummy crypt routines. Full versions in zcryp20k.zip.
! 13. Fixed the contents file.
! 14. Untabify everything to make diffs easier.
! 15. When zip is used to archive stdin, read the archive comment (-z) from
!     stderr instead of stdin. (Bill Davisen)
! 
! ------------------------ Sep 2nd  1993   version 2.0c ------------------------
! 1.  Allow the full zipcloak.c to be compiled with the dummy crypt.[ch].
! 2.  Set the directory attribute when creating directory entries.
! 3.  Add -p option to zipsplit to wait between diskettes. (Mark).
! 4.  On OS/2, accept volume label on a drive other than the current drive.
! 5.  Fix fileio for SGI.
! 6.  Add err() to the dummy zipcloak.c.
! 7.  Get match.asm from msdos subdirectory in all msdos makefiles.
! 8.  Default to -DDYN_ALLOC for MSC to reduce memory usage for -T.
! 9.  Set up the Where and README files for a zip 2.0 release.
! 10. Check sys/dirent.h instead of dirent.h in configure (temporary
!     hack until the big fileio.c cleanup).
! 11. Use only strrchr (already defined as rindex for some BSD systems).
! 12. Little Amiga patches in fileio.c and SMakeFile (John Bush).
! 
! 
! ------------------------ Sep 6th  1993   version 2.0d ------------------------
! 1.  Need sys/dir.h for NODIR option (James Birdsall)
! 2.  Define OS_CODE and GetFileMode for Human68k (NIIMI Satoshi)
! 3.  Added the zipgrep shell script and zipgrep.1.
! 4.  Fix in crypt.c for Convex (Rafal Maszkowski)
! 5.  Added nt/nt.c and fixed makefile.nt (Martin Schulz)
! 6.  Fix opendir/readdir for NT (Martin Schulz)
! 7.  Reverse the meaning of -D. Directory attributes are saved by
!     default. Use -D to disable creation of directory entries.
! 8.  Remove empty directories with -rm even if directory entries are not
!     created (-D).
! 9.  Support volume labels with DJGPP (MSDOS version of gcc).
! 10. Added initialization for z->dosflag.
! 11. In Makefile, use "sh configure flags" instead of "./configure flags" to
!     deal with some buggy versions of make (SunOS 4.1 /bin/make).
! 12. Made zcrypt20m.zip compatible with unzip 5.0p1, unzip 5.1e and zip 2.0d.
!     (However funzip from unz50p1 cannot compile with the new crypt.)
! 
! ------------------------ Sep 7th  1993   version 2.0e ------------------------
! 1.  Avoid warnings for NT and fix IsFileNameValid() (Steve Salisbury).
! 2.  Use only comment after #endif in crypt.c (zcryp20n).
! 3.  Put the correct README in zcryp20n.
! 4.  Allow chars above 0x80 in recmatch (Paul Kienitz)
! 5.  In recmatch, Allow "^" as well as "!" at the beginning of a set
!     (for example "[^0-9]") as a negation (Paul Kienitz)
! 6.  Better msdos/makefile.tc.
! 
! ------------------------ Sep 7th  1993   version 2.0f ------------------------
! 1.  Call FindClose in fileio.c, add nt/ntzip.h (Martin Schulz)
! 2.  Added "Why doesn't zip do <something> just like PKZIP does?" in README.
! 
! 
! ------------------------ Sep 7th  1993   version 2.0g -------------------------
! 1.  Fix wild() for human68k, jstring.h not needed (NIIMI Satoshi)
! 2.  wild() is needed for OS2 also (Kai Uwe)
! 3.  New os2/makefile.os2 (Kai Uwe)
! 
! ------------------------ Sep 7th  1993   version 2.0 -------------------------
! 1.  Define MODERN for VMS on Alpha (Hunter)
! 2.  In vms/VMSmunch.c, deal with variant_unions under Alpha (Hunter)
! 3.  Define main with int result (Hunter)
! 4.  Do not return a garbage exit code for zipsplit -t.
! 5.  Restore file attributes of an existing zip file (Igor)
! 6.  Define UTIL in globals.c and vms.c to avoid declaring read_buf (Hunter)
! 7.  Renamed make_vaxc.com as make_vms.com, make it work on AXP (Hunter).
! 8.  Added warning about OpenVMS AXP in vms/make_gcc.com (Hunter)
! 9.  Support OpenVMS AXP in vms/descrip.mms (Hunter)
! 10. Do not perform sliding with MMAP or BIG_MEM (Martin Schulz)
! 11. Recommend -DMMAP in install.doc.
! 12. Avoid WATCOM C bug in stat("*") (Thomas Opheys)
! 13. Avoid temp file name > 8 chars for NO_MKTEMP (Thomas Opheys)
Only in .: human68k
